#!/usr/bin/perl
use Proc::UID qw(:funcs);
use File::Pid;
use Getopt::Long;
use Proc::Daemon;

## HEY -- YOU SHOULD CHECK THIS
$binaryLocation = "/usr/local/games/cod4-linux-server";

$user = '';
$pidfile = '/var/run/cod4.pid';
$logfile = '';
$options = '';

GetOptions('user=s' => \$user,
	   'pidfile=s' => \$pidfile,
	   'logfile=s' => \$logfile,
	   'options=s' => \$options);

if ($user eq '' && $UID == 0) {
    die "You really should not run COD4 as root -- please specify a user";
}
Proc::Daemon::init();
my $pid = File::Pid->new({ file => $pidfile, });
$pid->write;

if ($logfile ne '') {
    open STDOUT, '>>', $logfile or die; 
    open STDERR, ">&STDOUT" or die;
    chomp($now = `date`);
    print "cod4_lnxded-wrap.pl started at $now\n";
}

if ($user ne '') {
    ($name,$passwd,$uid,$gid,
       $quota,$comment,$gcos,$dir,$shell,$expire) = getpwnam($user);
    drop_gid_perm($uid);
    drop_uid_perm($uid);
}

$ENV{'HOME'} = $dir;
chdir $binaryLocation;
exec "$binaryLocation/cod4_lnxded-bin $options";
